
-- Create the frame for the options panel
function Setup_RR_Panel()
 RaidRoll_Panel = {};
 RaidRoll_Panel.panel = CreateFrame( "Frame", "Raid Roll Panel", UIParent );
 -- Register in the Interface Addon Options GUI
 -- Set the name for the Category for the Options Panel
 RaidRoll_Panel.panel.name = "Raid Roll";
 -- Add the panel to the Interface Options
 InterfaceOptions_AddCategory(RaidRoll_Panel.panel);
 
 local x,y = 30,-120
 
 
-- Options menu
	Raid_Roll_PanelName_String =  RaidRoll_Panel.panel:CreateFontString("Raid_Roll_PanelName_String" ,"ARTWORK","GameFontNormal");
	Raid_Roll_PanelName_String:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopLeft", 20, -10)
	Raid_Roll_PanelName_String:SetJustifyH("LEFT")
	
	Raid_Roll_PanelName_String:SetText("|cFFC41F3B" .. LOCALE_RR_OPTIONSTITLE)
	Raid_Roll_PanelName_String:SetFont("Fonts\\FRIZQT__.TTF", 16)
	
-- Give Extra Priority to:
	Raid_Roll_PanelName_String =  RaidRoll_Panel.panel:CreateFontString("Raid_Roll_PanelName_String" ,"ARTWORK","GameFontNormal");
	Raid_Roll_PanelName_String:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopLeft", 20, -40)
	Raid_Roll_PanelName_String:SetJustifyH("LEFT")
	
	Raid_Roll_PanelName_String:SetText("|cFF2459FF" .. LOCALE_RR_General_Settings)
	Raid_Roll_PanelName_String:SetFont("Fonts\\FRIZQT__.TTF", 16)

 
-- [ ] Catch Unannounced Rolls
  	RR_RollCheckBox_Unannounced_panel = CreateFrame("CheckButton", "RR_RollCheckBox_Unannounced_panel", RaidRoll_Panel.panel, "UICheckButtonTemplate")
	RR_RollCheckBox_Unannounced_panel:SetWidth(20)
	RR_RollCheckBox_Unannounced_panel:SetHeight(20)
	RR_RollCheckBox_Unannounced_panel:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopLeft",  30, -60)
	_G["RR_RollCheckBox_Unannounced_panel".."Text"]:SetText("|cFFFFFFFF" .. LOCALE_RR_Catch_Unannounced_Rolls)
	_G["RR_RollCheckBox_Unannounced_panel".."Text"]:SetFont("Fonts\\FRIZQT__.TTF", 12)
	RR_RollCheckBox_Unannounced_panel:SetScript("OnClick",RaidRoll_CheckButton_Update_Panel)

-- [ ] Allow all rolls (e.g. 1-50)
	RR_RollCheckBox_AllRolls_panel = CreateFrame("CheckButton", "RR_RollCheckBox_AllRolls_panel", RaidRoll_Panel.panel, "UICheckButtonTemplate")
	RR_RollCheckBox_AllRolls_panel:SetWidth(20)
	RR_RollCheckBox_AllRolls_panel:SetHeight(20)
	RR_RollCheckBox_AllRolls_panel:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopLeft",  30, -80)
	_G["RR_RollCheckBox_AllRolls_panel".."Text"]:SetText("|cFFFFFFFF" .. LOCALE_RR_Allow_all_rolls)
	_G["RR_RollCheckBox_AllRolls_panel".."Text"]:SetFont("Fonts\\FRIZQT__.TTF", 12)
	RR_RollCheckBox_AllRolls_panel:SetScript("OnClick",RaidRoll_CheckButton_Update_Panel)
 
-- [ ] Allow Extra Rolls
 	RR_RollCheckBox_ExtraRolls_panel = CreateFrame("CheckButton", "RaidRollCheckBox_ExtraRolls_panel", RaidRoll_Panel.panel, "UICheckButtonTemplate")
	RR_RollCheckBox_ExtraRolls_panel:SetWidth(20)
	RR_RollCheckBox_ExtraRolls_panel:SetHeight(20)
	RR_RollCheckBox_ExtraRolls_panel:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopLeft",  30, -100)
	_G["RaidRollCheckBox_ExtraRolls_panel".."Text"]:SetText("|cFFFFFFFF" .. LOCALE_RR_Allow_Extra_Rolls)
	_G["RaidRollCheckBox_ExtraRolls_panel".."Text"]:SetFont("Fonts\\FRIZQT__.TTF", 12)
	RR_RollCheckBox_ExtraRolls_panel:SetScript("OnClick",RaidRoll_CheckButton_Update_Panel)


-- Display Settings
	Raid_Roll_Display_Settings =  RaidRoll_Panel.panel:CreateFontString("Raid_Roll_Display_Settings" ,"ARTWORK","GameFontNormal");
	Raid_Roll_Display_Settings:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopLeft", 20, -140)
	Raid_Roll_Display_Settings:SetJustifyH("LEFT")
	
	Raid_Roll_Display_Settings:SetText("|cFF2459FF" .. LOCALE_RR_Raid_Roll_Display_Settings)
	Raid_Roll_Display_Settings:SetFont("Fonts\\FRIZQT__.TTF", 16)
	
-- [ ] Show Rank Beside Name
	RR_RollCheckBox_ShowRanks_panel = CreateFrame("CheckButton", "RaidRollCheckBox_ShowRanks_panel", RaidRoll_Panel.panel, "UICheckButtonTemplate")
	RR_RollCheckBox_ShowRanks_panel:SetWidth(20)
	RR_RollCheckBox_ShowRanks_panel:SetHeight(20)
	RR_RollCheckBox_ShowRanks_panel:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopLeft",  30, -160)
	_G["RaidRollCheckBox_ShowRanks_panel".."Text"]:SetText("|cFFFFFFFF" .. LOCALE_RR_Show_Rank_Beside_Name)
	_G["RaidRollCheckBox_ShowRanks_panel".."Text"]:SetFont("Fonts\\FRIZQT__.TTF", 12)
	RR_RollCheckBox_ShowRanks_panel:SetScript("OnClick",RaidRoll_CheckButton_Update_Panel)
	
-- [ ] Show Group Number Beside Name
	RR_RollCheckBox_ShowGroupNumber_panel = CreateFrame("CheckButton", "RR_RollCheckBox_ShowGroupNumber_panel", RaidRoll_Panel.panel, "UICheckButtonTemplate")
	RR_RollCheckBox_ShowGroupNumber_panel:SetWidth(20)
	RR_RollCheckBox_ShowGroupNumber_panel:SetHeight(20)
	RR_RollCheckBox_ShowGroupNumber_panel:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopLeft",  30, -180)
	_G["RR_RollCheckBox_ShowGroupNumber_panel".."Text"]:SetText("|cFFFFFFFF" .. LOCALE_RR_Show_Group_Beside_Name)
	_G["RR_RollCheckBox_ShowGroupNumber_panel".."Text"]:SetFont("Fonts\\FRIZQT__.TTF", 12)
	RR_RollCheckBox_ShowGroupNumber_panel:SetScript("OnClick",RaidRoll_CheckButton_Update_Panel)
	
-- Give Extra Priority to:
	Raid_Roll_PanelName_String =  RaidRoll_Panel.panel:CreateFontString("Raid_Roll_PanelName_String" ,"ARTWORK","GameFontNormal");
	Raid_Roll_PanelName_String:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopRight", -210, -50)
	Raid_Roll_PanelName_String:SetJustifyH("LEFT")
	
	Raid_Roll_PanelName_String:SetText("|cFF2459FF" .. LOCALE_RR_Priorities)
	Raid_Roll_PanelName_String:SetFont("Fonts\\FRIZQT__.TTF", 16)

	
-- [  ] Give Higher Ranks Priority
	RR_RollCheckBox_RankPrio_panel = CreateFrame("CheckButton", "RaidRollCheckBox_RankPrio_panel", RaidRoll_Panel.panel, "UICheckButtonTemplate")
	RR_RollCheckBox_RankPrio_panel:SetWidth(20)
	RR_RollCheckBox_RankPrio_panel:SetHeight(20)
	RR_RollCheckBox_RankPrio_panel:SetPoint("TopLeft", RaidRoll_Panel.panel, "TopRight", -200, -70)
	_G["RaidRollCheckBox_RankPrio_panel".."Text"]:SetText("|cFFFFFFFF" .. LOCALE_RR_Give_Higher_Ranks_Priority)
	_G["RaidRollCheckBox_RankPrio_panel".."Text"]:SetFont("Fonts\\FRIZQT__.TTF", 12)
	RR_RollCheckBox_RankPrio_panel:SetScript("OnClick",RaidRoll_CheckButton_Update_Panel)
	
 
 --------------------SLIDER BAR 1 : Scale--------------------------------

 -- Set Scale
	Raid_Roll_PanelName_String =  RaidRoll_Panel.panel:CreateFontString("Raid_Roll_PanelName_String" ,"ARTWORK","GameFontNormal");
	Raid_Roll_PanelName_String:SetPoint("TopLeft", RaidRoll_Panel.panel, "TOPLEFT", 10, -245)
	Raid_Roll_PanelName_String:SetJustifyH("LEFT")
	
	Raid_Roll_PanelName_String:SetText("|cFF69CCF0" .. LOCALE_RR_Set_Scale)
	Raid_Roll_PanelName_String:SetFont("Fonts\\FRIZQT__.TTF", 14)

 RaidRoll_Scale_Slider = CreateFrame("Slider", "RaidRoll_Scale_Slider", RaidRoll_Panel.panel, "OptionsSliderTemplate")
 RaidRoll_Scale_Slider:SetWidth(300)
 RaidRoll_Scale_Slider:SetHeight( 20 )
 RaidRoll_Scale_Slider:SetPoint('TOPLEFT', 20, -270)
 RaidRoll_Scale_Slider:SetOrientation('HORIZONTAL')
 

	if RaidRoll_DB["Scale"] == nil then RaidRoll_DB["Scale"] = 100 end
 
 RaidRoll_Scale_Slider:SetMinMaxValues(1, 200)
 RaidRoll_Scale_Slider:SetValueStep(1)
 RaidRoll_Scale_Slider:SetValue(RaidRoll_DB["Scale"])
 
 
 
	_G[RaidRoll_Scale_Slider:GetName() .. 'Low']:SetText('1%');
	_G[RaidRoll_Scale_Slider:GetName() .. 'High']:SetText('200%'); 	
	_G[RaidRoll_Scale_Slider:GetName() .. 'Text']:SetText(RaidRoll_Scale_Slider:GetValue() .. "%");


 RaidRoll_Scale_Slider:Show()
 
 RR_RollFrame:SetScale(RaidRoll_Scale_Slider:GetValue()/100);
 
 
  RaidRoll_Scale_Slider:SetScript("OnValueChanged",function()
	RR_RollFrame:SetScale(RaidRoll_Scale_Slider:GetValue()/100);
	_G[RaidRoll_Scale_Slider:GetName() .. 'Text']:SetText(RaidRoll_Scale_Slider:GetValue() .. "%");
	RaidRoll_DB["Scale"] = RaidRoll_Scale_Slider:GetValue()
  end)
 ----------------------------------------------------
 
 
 
 
 --------------------SLIDER BAR 2 : Extra Rank Width--------------------------------

 -- Set Extra Rank Width
	Raid_Roll_PanelName_String =  RaidRoll_Panel.panel:CreateFontString("Raid_Roll_PanelName_String" ,"ARTWORK","GameFontNormal");
	Raid_Roll_PanelName_String:SetPoint("TopLeft", RaidRoll_Panel.panel, "TOPLEFT", 10, -310)
	Raid_Roll_PanelName_String:SetJustifyH("LEFT")
	
	Raid_Roll_PanelName_String:SetText("|cFF69CCF0" .. LOCALE_RR_Set_Scale)
	Raid_Roll_PanelName_String:SetFont("Fonts\\FRIZQT__.TTF", 14)

 RaidRoll_ExtraWidth_Slider = CreateFrame("Slider", "RaidRoll_ExtraWidth_Slider", RaidRoll_Panel.panel, "OptionsSliderTemplate")
 RaidRoll_ExtraWidth_Slider:SetWidth(300)
 RaidRoll_ExtraWidth_Slider:SetHeight( 20 )
 RaidRoll_ExtraWidth_Slider:SetPoint('TOPLEFT', 20, -335)
 RaidRoll_ExtraWidth_Slider:SetOrientation('HORIZONTAL')
 

	if RR_ExtraWidth == nil then RR_ExtraWidth = 0 end
 
 RaidRoll_ExtraWidth_Slider:SetMinMaxValues(0, 200)
 RaidRoll_ExtraWidth_Slider:SetValueStep(1)
 RaidRoll_ExtraWidth_Slider:SetValue(RR_ExtraWidth)
 
 
 
	_G[RaidRoll_ExtraWidth_Slider:GetName() .. 'Low']:SetText('0');
	_G[RaidRoll_ExtraWidth_Slider:GetName() .. 'High']:SetText('200'); 	
	_G[RaidRoll_ExtraWidth_Slider:GetName() .. 'Text']:SetText(RaidRoll_ExtraWidth_Slider:GetValue());


 RaidRoll_ExtraWidth_Slider:Show()
 
 
 
  RaidRoll_ExtraWidth_Slider:SetScript("OnValueChanged",function()
	RaidRoll_CheckButton_Update_Panel()
	_G[RaidRoll_ExtraWidth_Slider:GetName() .. 'Text']:SetText(RaidRoll_ExtraWidth_Slider:GetValue());
	RR_ExtraWidth = RaidRoll_ExtraWidth_Slider:GetValue()
  end)
 ----------------------------------------------------
 
 
 
	RR_Panel_GuildRankFrame = CreateFrame("Frame","RR_Panel_GuildRankFrame",RaidRoll_Panel.panel)
	
	local backdrop = {
	  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  -- path to the background texture
	  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",  -- path to the border texture
	  
	  tile = true,    -- true to repeat the background texture to fill the frame, false to scale it
	  tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
	  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
	  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
	    left = 4,
	    right = 4,
	    top = 4,
	    bottom = 4
	  }
	}


	RR_Panel_GuildRankFrame:SetBackdrop(backdrop)

	RR_Panel_GuildRankFrame:SetWidth(180) -- Set these to whatever height/width is needed 
	RR_Panel_GuildRankFrame:SetHeight(200) -- for your Texture
	RR_Panel_GuildRankFrame:SetPoint("TopRight",RaidRoll_Panel.panel,"TopRight",-20,-90);
	
-- Create a list of the 10 Guild Ranks, the title "guild ranks" and a "not in guild" rank
	Raid_Roll_GuildRank_String = RR_Panel_GuildRankFrame:CreateFontString("Raid_Roll_GuildRank_String"..0 ,"ARTWORK","GameFontNormal");
	Raid_Roll_GuildRank_String:SetPoint("TOPLEFT",RR_Panel_GuildRankFrame,5, -8);
	Raid_Roll_GuildRank_String:SetJustifyH("LEFT")
	Raid_Roll_GuildRank_String:SetWidth(200); 
	Raid_Roll_GuildRank_String:SetHeight(11); 
	
	Raid_Roll_GuildRank_String:SetText("Guild Rank")
	
	for i=1,11 do
		Raid_Roll_GuildRank_String_i = RR_Panel_GuildRankFrame:CreateFontString("Raid_Roll_GuildRank_String"..i ,"ARTWORK","GameFontNormal");
		Raid_Roll_GuildRank_String_i:SetPoint("TOPLEFT",_G["Raid_Roll_GuildRank_String"..i-1],0, -15);
		Raid_Roll_GuildRank_String_i:SetJustifyH("LEFT")
		Raid_Roll_GuildRank_String_i:SetWidth(200); 
		Raid_Roll_GuildRank_String_i:SetHeight(11); 
		
		
		Raid_Roll_GuildRank_String_i:SetText("# " .. i .. " : " .. GuildControlGetRankName(i))
		
		if i == 10 then Raid_Roll_GuildRank_String_i:SetText("#" .. i .. ": " .. GuildControlGetRankName(i)) end
		
		
		--	/run RR_Test(GetGuildInfoText())
		
		if i == 11 then Raid_Roll_GuildRank_String_i:SetText("Not in Guild") end
	end
	
	
-- Create 11  priority indexes and the name "priorities"
	Raid_Roll_GuildPriority_String = RR_Panel_GuildRankFrame:CreateFontString("Raid_Roll_GuildPriority"..0 ,"ARTWORK","GameFontNormal");
	Raid_Roll_GuildPriority_String:SetPoint("TOPRIGHT",RR_Panel_GuildRankFrame,-8, -8);
	Raid_Roll_GuildPriority_String:SetJustifyH("RIGHT")
	Raid_Roll_GuildPriority_String:SetWidth(200); 
	Raid_Roll_GuildPriority_String:SetHeight(11); 
	
	Raid_Roll_GuildPriority_String:SetText("Priority")
	
	for i=1,12 do
		if i ~= 12 then 
			Raid_Roll_GuildPriority_i = CreateFrame("Button", "Raid_Roll_GuildPriority"..i, RR_Panel_GuildRankFrame, "UIPanelButtonTemplate")
			Raid_Roll_GuildPriority_i:SetWidth(16)
			Raid_Roll_GuildPriority_i:SetHeight(16)
			Raid_Roll_GuildPriority_i:SetPoint("TOPRIGHT",_G["Raid_Roll_GuildPriority"..i-1],0, -15);
			
			Raid_Roll_GuildPriority_i:SetScript("OnClick",	function()
															RR_Priority_Modify(i)
															end)
		end
		
		
		if RaidRoll_DB["Rank Priority"]    == nil then RaidRoll_DB["Rank Priority"]    = {} end
		if RaidRoll_DB["Rank Priority"][i] == nil then RaidRoll_DB["Rank Priority"][i] = 11-i  end
		
		if i ~= 12 then Raid_Roll_GuildPriority_i:SetText(RaidRoll_DB["Rank Priority"][i]) end
	end
end

function RR_Priority_Modify(Priority_Index)

	if RaidRoll_DB["debug"] == true then RR_Test("Priority_Index" .. Priority_Index) end

	RaidRoll_DB["Rank Priority"][Priority_Index] = RaidRoll_DB["Rank Priority"][Priority_Index] + 1

	if RaidRoll_DB["Rank Priority"][Priority_Index] >= 11 then RaidRoll_DB["Rank Priority"][Priority_Index] = 0 end

	_G["Raid_Roll_GuildPriority"..Priority_Index]:SetText(RaidRoll_DB["Rank Priority"][Priority_Index])

	rr_RollSort(rr_CurrentRollID)
	RR_Display(rr_CurrentRollID)
end

-- Called to update the options panel checkboxes
function RaidRoll_CheckButton_Update_Panel()

--RaidRoll_Allow_All:SetChecked(true);
	if  RR_RollCheckBox_Unannounced_panel:GetChecked() then
		RR_Track_Unannounced_Rolls =  true
		RaidRoll_Catch_All:SetChecked(true)
		RR_RollCheckBox_Unannounced_panel:SetChecked(true)
		--RR_Test("Raid Roll: Auto-Tracking Rolls Enabled")
	else
		RR_Track_Unannounced_Rolls =  false
		RaidRoll_Catch_All:SetChecked(false)
		RR_RollCheckBox_Unannounced_panel:SetChecked(false)
		--RR_Test("Raid Roll: Auto-Tracking Rolls Disabled")
	end

	if  RR_RollCheckBox_AllRolls_panel:GetChecked() then
		RR_Accept_All_Rolls =  true
		RaidRoll_Allow_All:SetChecked(true)
		RR_RollCheckBox_AllRolls_panel:SetChecked(true)
		--RR_Test("Raid Roll: All rolls accepted")
	else
		RR_Accept_All_Rolls =  false
		RaidRoll_Allow_All:SetChecked(false)
		RR_RollCheckBox_AllRolls_panel:SetChecked(false)
		--RR_Test("Raid Roll: Only 1-100 rolls accepted")
	end
	
	if RR_RollCheckBox_ExtraRolls_panel:GetChecked() then
		RR_AllowExtraRolls =  true
		RR_RollCheckBox_ExtraRolls:SetChecked(true)
		RR_RollCheckBox_ExtraRolls_panel:SetChecked(true)
		--RR_Test("Raid Roll: All rolls accepted")
	else
		RR_AllowExtraRolls =  false
		RR_RollCheckBox_ExtraRolls:SetChecked(false)
		RR_RollCheckBox_ExtraRolls_panel:SetChecked(false)
		--RR_Test("Raid Roll: Only 1-100 rolls accepted")
	end

	if  RR_RollCheckBox_ShowRanks_panel:GetChecked() then
		RR_Show_Ranks =  true
		--RR_RollCheckBox_ShowRanks:SetChecked(true)
		RR_RollCheckBox_ShowRanks_panel:SetChecked(true)
		for i=1,6 do
			_G["Raid_Roll_Rank_String"..i-1]:Show()
		end
		RR_RollFrame:SetWidth(265+RR_ExtraWidth)
		_G["RR_Rolled"]:ClearAllPoints()
		_G["RR_Rolled"]:SetPoint("TOPLEFT", _G["RR_RollFrame"], "TOPLEFT",170+RR_ExtraWidth,-30)
		
		_G["RR_Group0"]:ClearAllPoints()
		_G["RR_Group0"]:SetPoint("TOPLEFT", _G["RR_RollFrame"], "TOPLEFT",220+RR_ExtraWidth,-30)
	else
		RR_Show_Ranks =  false
		--RR_RollCheckBox_ShowRanks:SetChecked(false)
		RR_RollCheckBox_ShowRanks_panel:SetChecked(false)
		for i=1,6 do
			
			_G["Raid_Roll_Rank_String"..i-1]:Hide()
		end
		RR_RollFrame:SetWidth(215+RR_ExtraWidth)
		_G["RR_Rolled"]:ClearAllPoints()
		_G["RR_Rolled"]:SetPoint("TOPLEFT", _G["RR_RollFrame"], "TOPLEFT",120+RR_ExtraWidth,-30)
		
		_G["RR_Group0"]:ClearAllPoints()
		_G["RR_Group0"]:SetPoint("TOPLEFT", _G["RR_RollFrame"], "TOPLEFT",170+RR_ExtraWidth,-30)
		
	end
	
	if RR_RollCheckBox_ShowGroupNumber_panel:GetChecked() then
		RR_ShowGroupNumber =  true
		RR_RollCheckBox_ShowGroupNumber_panel:SetChecked(true)
		
		for i=1,6 do
			_G["RR_Group"..i-1]:Show()
		end
		
		--RR_RollFrame:SetWidth(215+RR_ExtraWidth)
	else
		RR_ShowGroupNumber =  false
		RR_RollCheckBox_ShowGroupNumber_panel:SetChecked(false)
		
		for i=1,6 do
			_G["RR_Group"..i-1]:Hide()
		end
		
		RR_RollFrame:SetWidth(RR_RollFrame:GetWidth() - 30)
	end
	
	
	if RR_RollCheckBox_RankPrio_panel:GetChecked() then
		RR_RankPriority =  true
		--RR_RollCheckBox_RankPrio:SetChecked(true)
		RR_RollCheckBox_RankPrio_panel:SetChecked(true)
		--RR_Test("Raid Roll: All rolls accepted")
	else
		RR_RankPriority =  false
		--RR_RollCheckBox_RankPrio:SetChecked(false)
		RR_RollCheckBox_RankPrio_panel:SetChecked(false)
		--RR_Test("Raid Roll: Only 1-100 rolls accepted")
	end
	
	rr_RollSort(rr_CurrentRollID)
	
	if RR_HasDisplayedAlready ~= nil then
		RR_Display(rr_CurrentRollID)
	end
	
	for i=1,5 do
		_G["Raid_Roll_Rank_String"..i]:SetWidth(65+RR_ExtraWidth); 
	end
end
